<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="110px">
      <el-form-item label="检查对象分类" prop="fTypeCode">
        <el-select v-model="queryParams.fTypeCode" placeholder="请选择检查对象分类" clearable size="small">
          <el-option
            v-for="dict in fTypeCodeOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="结果填写类型" prop="fResType">
        <el-select v-model="queryParams.fResType" placeholder="请选择结果填写类型" clearable size="small">
          <el-option
            v-for="dict in fResTypeOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
		      :loading="exportLoading"
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="inforList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="检查任务编码" align="center" prop="fCheckTaskCode" />
      <el-table-column label="检查对象分类" align="center" prop="fTypeCode" :formatter="fTypeCodeFormat" />
      <el-table-column label="调查内容" align="center" prop="fContents">
        <template slot-scope="scope">
          <span v-if="scope.row.fContents">{{ scope.row.fContents }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="结果填写类型" align="center" prop="fResType" :formatter="fResTypeFormat" />
      <el-table-column label="结果填写选项" align="center" prop="fResOption">
        <template slot-scope="scope">
          <span v-if="scope.row.fResOption">{{ scope.row.fResOption }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="顺序号" align="center" prop="ord">
        <template slot-scope="scope">
          <span v-if="scope.row.ord">{{ scope.row.ord }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="最后修改时间" align="center" prop="fLastUpdateTime" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-document"
            @click="handleDetail(scope.row)"
          >详情</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改调查项对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body destroy-on-close :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="检查任务编码" prop="fCheckTaskCode">
          <el-select
            v-model="form.fCheckTaskCode"
            placeholder="请选择任务编码"
            style="width: 100%"
          >
            <el-option
              v-for="task in taskData"
              :key="task.fInsTaskInforId"
              :label="task.fUniqueCode"
              :value="task.fUniqueCode"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="检查对象分类" prop="fTypeCode">
          <el-select
            v-model="form.fTypeCode"
            placeholder="请选择检查对象分类"
            style="width: 100%"
          >
            <el-option
              v-for="dict in fTypeCodeOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="调查内容" prop="fContents">
          <el-input type="textarea" v-model="form.fContents" placeholder="请输入调查内容" />
        </el-form-item>
        <el-form-item label="结果填写类型" prop="fResType">
          <el-select
            v-model="form.fResType"
            placeholder="请选择结果填写类型"
            style="width: 100%"
          >
            <el-option
              v-for="dict in fResTypeOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="parseInt(dict.dictValue)"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="结果填写选项" prop="fResOption">
          <el-input v-model="form.fResOption" placeholder="请输入结果填写选项" />
        </el-form-item>
        <el-form-item label="顺序号" prop="ord">
          <el-input v-model="form.ord" placeholder="请输入顺序号" />
        </el-form-item>
        <!--<el-form-item label="最后修改时间" prop="fLastUpdateTime">
          <el-input v-model="form.fLastUpdateTime" placeholder="请输入最后修改时间" />
        </el-form-item>-->
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 详情 -->
    <DetailInfo ref="detail"/>
  </div>
</template>

<script>
import { listInfor, getInfor, delInfor, addInfor, updateInfor, exportInfor } from "@/api/supervision/survey";
import { taskList } from "@/api/supervision/task";
import DetailInfo from "./components/DetailInfo";
export default {
  name: "Infor",
  components: {
    DetailInfo
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 调查项表格数据
      inforList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 检查对象分类
      fTypeCodeOptions: [],
      // 结果填写类型
      fResTypeOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        fTypeCode: null,
        fResType: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        fCheckTaskCode: [
          { required: true, message: "请选择检查项任务编码", trigger: "change" }
        ],
        fTypeCode: [
          { required: true, message: "请选择检查对象分类", trigger: "change" }
        ],
        fResType: [
          { required: true, message: "请选择结果填写类型", trigger: "change" }
        ],
      },
      taskData: []
    };
  },
  created() {
    this.getList();
    this.getDicts("t_type_code").then(response => {
      this.fTypeCodeOptions = response.data;
    });
    this.getDicts("f_res_type").then(response => {
      this.fResTypeOptions = response.data;
    });
  },
  methods: {
    /** 查询调查项列表 */
    getList() {
      this.loading = true;
      listInfor(this.queryParams).then(response => {
        this.inforList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 检查对象分类
    fTypeCodeFormat(row, column) {
      return this.selectDictLabel(this.fTypeCodeOptions, row.fTypeCode);
    },
    // 结果填写类型，1单选、2-多选、3 输入字典翻译
    fResTypeFormat(row, column) {
      return this.selectDictLabel(this.fResTypeOptions, row.fResType);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        fInsSurListInforId: null,
        fCheckTaskCode: null,
        fTypeCode: null,
        fContents: null,
        fResType: null,
        fResOption: null,
        ord: null,
        fLastUpdateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.fInsSurListInforId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.getTaskList();
      this.open = true;
      this.title = "添加调查项";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const fInsSurListInforId = row.fInsSurListInforId || this.ids
      getInfor(fInsSurListInforId).then(response => {
        this.form = response.data;
        this.getTaskList();
        this.open = true;
        this.title = "修改调查项";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.fInsSurListInforId != null) {
            updateInfor(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addInfor(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const fInsSurListInforIds = row.fInsSurListInforId || this.ids;
      this.$confirm('是否确认删除调查项编号为"' + fInsSurListInforIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delInfor(fInsSurListInforIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有调查项数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportInfor(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    },
    //任务列表
    getTaskList(){
      taskList().then(res =>{
          if(res.code == 200 && res.data){
          this.taskData = res.data;
        }
      })
    },
    //详情
    handleDetail(row){
      this.$refs.detail.getDetailInfo(row.fInsSurListInforId);
    },
  }
};
</script>
